/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package hyperjax.test;

import generated.ObjectFactory;
import generated.PurchaseOrderType;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;

/**
 *
 * @author Markus Roskosch
 */
public class Helper {
    
private JAXBContext context;

private ObjectFactory objectFactory;

private EntityManagerFactory entityManagerFactory;
    
public long start(Object o) throws Exception{
    
    setUp();
        
    final Object object;
    final Unmarshaller unmarshaller = context.createUnmarshaller();
    final PurchaseOrderType purchaseOrder;
       
    if(o!=null){
        String purchaseOrderString = (String) o;
        InputStream stream = new ByteArrayInputStream(purchaseOrderString.getBytes("UTF-8"));
        object = unmarshaller.unmarshal(stream);
        purchaseOrder = ((JAXBElement<PurchaseOrderType>) object).getValue();
    }else{
    
    object = unmarshaller.unmarshal(new File("src/test/samples/po.xml"));
    purchaseOrder = ((JAXBElement<PurchaseOrderType>) object).getValue();
    
    }
    
    long id = persist(purchaseOrder);
    
    return id;
    }


public long persist(PurchaseOrderType purchaseOrder){
    try {
        setPersistenceProperties();
    } catch (IOException ex) {
        Logger.getLogger(Helper.class.getName()).log(Level.SEVERE, null, ex);
    }
    
    final EntityManager saveManager = entityManagerFactory
	.createEntityManager();
    saveManager.getTransaction().begin();
    saveManager.persist(purchaseOrder);
    saveManager.getTransaction().commit();
    saveManager.close();
    
    return purchaseOrder.getHjid();
}

public String loadAsString(long id){
    final EntityManager loadManager = entityManagerFactory
		.createEntityManager();
    final PurchaseOrderType beta = loadManager.find(
                    PurchaseOrderType.class, id);
    
    final Marshaller marshaller;
    OutputStream os = new ByteArrayOutputStream();
    
    try {
        marshaller = context.createMarshaller();
        marshaller.marshal(objectFactory.createPurchaseOrder(beta), os);
    } catch (JAXBException ex) {
        Logger.getLogger(Helper.class.getName()).log(Level.SEVERE, null, ex);
    }
    
    loadManager.close();
            
    return os.toString();
}


public void setPersistenceProperties() throws IOException{
    
    final Properties persistenceProperties = new Properties();
    InputStream is = null;
    try {
            is = getClass().getClassLoader().getResourceAsStream(
                            "persistence.properties");
            persistenceProperties.load(is);
    } finally {
            if (is != null) {
                    try {
                            is.close();
                    } catch (IOException ignored) {
                    }
            }
    }

    entityManagerFactory = new Persistence().createEntityManagerFactory("generated", persistenceProperties);
    }  

protected void setUp() throws Exception {
    context = JAXBContext.newInstance("generated");
    objectFactory = new ObjectFactory();
    }
    
public void setUpPersistence() throws Exception {
    entityManagerFactory = Persistence.createEntityManagerFactory("generated");
    }

}
